#include "stdafx.h"
#include <math.h>
#include "FitFunction.h"

float CFitFunction::Calculate (float x) {
	void plateau (float x, float a[], float * y, float dyda[], int na);
	void fintgauss (float, float*, float*, float*, int);
	//void intgausscomp (float, float*, float*, float*, int);
  	void intgausscomp (float x, float a[], float * y, float dyda[], int na);
	float y=0, a[4], dyda[4];

	switch (type) {
	case LineType:
		y=exp(p1+x*p2);
		break;
	case StepType:
		a[1]=p1;
		a[2]=p2;
		a[3]=p3;
		plateau (x, a, &y, dyda, 0);
		break;
	case ErrorType:
		a[1]=p1;
		a[2]=p2;
		fintgauss (x, a, &y, dyda, 0);
		break;
	case InvErrorType:
		a[1]=p1;
		a[2]=p2;
		intgausscomp (x, a, &y, dyda, 0);
		break;
	default:
		TRACE ("CFitFunction::Calculate: unknown function type!\n");
		y=0;
	}
	return y;
}

CFitFunction::CFitFunction (FitType t, float par1, float par2, float par3){
	type=t;
	p1=par1;
	p2=par2;
	p3=par3;
}

CFitFunction::~CFitFunction (){
}


