// GraphControl.cpp : implementation file
//
// Dynamic subclassing, age 346 in "Inside Visual C++"

#include "stdafx.h"
#include "Aldas.h"
#include "Axis.h"
#include "NoiseFitDlg.h"
#include "FitFunction.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CGraphControl

CGraphControl::CGraphControl(CAxis *x, CAxis *y, CFitFunction* f)
{
	xAxis=x;
	yAxis=y;
	func=f;
}

CGraphControl::~CGraphControl()
{
}


BEGIN_MESSAGE_MAP(CGraphControl, CStatic)
	//{{AFX_MSG_MAP(CGraphControl)
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CGraphControl message handlers

void CGraphControl::OnPaint() 
{  
	CPaintDC dc(this); // device context for painting
	
	CRect client, rect;
	GetClientRect(&client);
	int wid=client.Width();
	int hei=client.Height();
	int i, ix, iy;
	float x, y, range;

	int d=10; // margin 
	
	dc.FillSolidRect(client, RGB(255,255,255));  // bkgnd

	if (xAxis==NULL) {
		dc.TextOut (wid/2-20, hei/2, "xAxis=NULL!");
   return;
  }

  rect=CRect(client.left+d, client.top+d, client.right-d, client.bottom-d);
  if (yAxis == NULL) {
	  if (viewMode==LineFitView) {
		  xAxis->DrawYScale(&dc, rect);
		  xAxis->DrawData(&dc, rect);
	  } 
	  if (viewMode==HistogramView) {
		  xAxis->DrawHistogram(&dc, rect);
	  } 	
  } else {
    yAxis->PlotVersus(&dc, rect, xAxis);
  }

  if (func == NULL) return; // nothing more to draw.

  range=xAxis->GetHigh()-xAxis->GetLow();
  x=xAxis->GetLow();
  ix=xAxis->MapXValue(x);
  y=func->Calculate(x);
  iy=yAxis->MapYValue(y);
  dc.MoveTo(ix, iy);
  for (i=1; i<=50; i++){
	 x=xAxis->GetLow()+i*range/50.0;
	 ix=xAxis->MapXValue(x);
	 y=func->Calculate(x);
	 iy=yAxis->MapYValue(y);
	 if ((y<yAxis->GetHigh())&&(y>yAxis->GetLow())) {
		dc.LineTo(ix, iy);
	 } else {
		dc.MoveTo(ix, iy);
	 } 
  }
}


void CGraphControl::Init (CAxis* x, CAxis* y, CFitFunction* f, VIEWMODE mode)
{
	xAxis=x;
	yAxis=y;
	func=f;
	viewMode=mode;
}
