// DSPDlg.cpp : implementation file

#include "stdafx.h"

#include "ALDAS.h"
#include "PlaceDoc.h"
#include "ALDASDoc.h"
#include "ALDASView.h"

#include "message.h"
#include "llcard.h"
#include "dspcard.h"
#include "TccCard.h"
#include "LLDialog.h"
#include "DSPDlg.h"
#include "TccDlg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// CDSPDlg dialog


CDSPDlg::CDSPDlg(CWnd* pParent, DSP * d)
	: CDialog(CDSPDlg::IDD, pParent)
{
	mdsp = d;
	//{{AFX_DATA_INIT(CDSPDlg)
	calibration = 0.0f;
	threshold = 0.0f;
	vatt = 0.0f;
	vref = 0.0f;
//	strobedelay = 0;
	dataready = FALSE;
	endofburst = FALSE;
	startofburst = FALSE;
	trigger = FALSE;
	verbose = FALSE;
	abort = FALSE;
	//}}AFX_DATA_INIT
//	mdsp=NULL;
}


void CDSPDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDSPDlg)
	DDX_Text(pDX, IDC_CALIBRATION, calibration);
	DDV_MinMaxFloat(pDX, calibration, 0.f, 2.5f);
	DDX_Text(pDX, IDC_THRESHOLD, threshold);
	DDV_MinMaxFloat(pDX, threshold, 0.f, 2.5f);
	DDX_Text(pDX, IDC_VATT, vatt);
	DDV_MinMaxFloat(pDX, vatt, 0.f, 2.5f);
	DDX_Text(pDX, IDC_VREF, vref);
	DDV_MinMaxFloat(pDX, vref, 0.f, 2.5f);
//	DDX_Text(pDX, IDC_STROBEDELAY, strobedelay);
//	DDV_MinMaxInt(pDX, strobedelay, 0, 255);
	DDX_Check(pDX, IDC_DATAREADY, dataready);
	DDX_Check(pDX, IDC_ENDOFBURST, endofburst);
	DDX_Check(pDX, IDC_STARTOFBURST, startofburst);
	DDX_Check(pDX, IDC_TRIGGER, trigger);
	DDX_Check(pDX, IDC_VERBOSE, verbose);
	DDX_Check(pDX, IDC_ABORT, abort);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CDSPDlg, CDialog)
	//{{AFX_MSG_MAP(CDSPDlg)
	ON_BN_CLICKED(IDC_LLCARD, OnLLcard)
	ON_BN_CLICKED(IDC_TCCCARD, OnTccCard)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// CDSPDlg message handlers

void CDSPDlg::InitDlg(DSP * adsp) {
	mdsp = adsp;
/*	threshold=0.0001*int(0.5+10000*mdsp->GetDACVoltage(0));
	vref=0.0001*int(0.5+10000*mdsp->GetDACVoltage(1));
	vatt=0.0001*int(0.5+10000*mdsp->GetDACVoltage(2));
	calibration=0.0001*int(0.5+10000*mdsp->GetDACVoltage(3));

	// Flags
	abort=(mdsp->GetFlag(ABORT_FLAG)!=0);
	startofburst=(mdsp->GetFlag(SOB_SIG_FLAG)!=0);
	endofburst=(mdsp->GetFlag(EOB_SIG_FLAG)!=0);
	trigger=(mdsp->GetFlag(TRIGGER_FLAG)!=0);
	verbose=(mdsp->GetFlag(VERBOSE_FLAG)!=0);
	dataready=(mdsp->GetFlag(DSP_DATA_READY_FLAG)!=0);*/
}


void CDSPDlg::OnLLcard() 
{
	LLCard * mllcard = mdsp->GetLLCard();
	if (mllcard==NULL) return;
	
	CLLDialog mdlg(this, mllcard);
	mdlg.DoModal();
}

void CDSPDlg::OnOK()
{
	char buf[500];
	int i=0;
	UpdateData();
	try {
	mdsp->SetDACVoltage(0, threshold);
	mdsp->SetDACVoltage(1, vref);
	mdsp->SetDACVoltage(2, vatt);
	mdsp->SetDACVoltage(3, calibration);
	} catch (int errorCode) {
		i = sprintf(buf, "The DSP did not set the DAC voltages correctly.\n");
		i += sprintf(buf+i, "Possible reasons: The start of burst flag is\n");
		i += sprintf(buf+i, "enabled.\n");
//		i += sprintf(buf+i, "into the SLL card or that the TCC card is present.\n");
//		i += sprintf(buf+i, "Click Retry to reboot the DSP, Cancel to give up.\n");
		AfxMessageBox(buf, MB_ICONSTOP|MB_RETRYCANCEL);
//			mCardIsReady = FALSE;
	}
	// Flags
	mdsp->SetFlag(ABORT_FLAG, abort?1:0);
	mdsp->SetFlag(SOB_SIG_FLAG, startofburst?1:0);
	mdsp->SetFlag(EOB_SIG_FLAG, endofburst?1:0);
	mdsp->SetFlag(TRIGGER_FLAG, trigger?1:0);
	mdsp->SetFlag(VERBOSE_FLAG, verbose?1:0);
	mdsp->SetFlag(DSP_DATA_READY_FLAG, dataready);

	CDialog::OnOK();
}

void CDSPDlg::OnTccCard() 
{
	TccCard * tcc = mdsp->GetTccCard();
	if (tcc == NULL) return;
//	tcc->GetTccCardStatus();

	CTccDlg dlg(this, tcc);
	dlg.DoModal();
}

BOOL CDSPDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	threshold=0.0001*int(0.5+10000*mdsp->GetDACVoltage(0));
	vref=0.0001*int(0.5+10000*mdsp->GetDACVoltage(1));
	vatt=0.0001*int(0.5+10000*mdsp->GetDACVoltage(2));
	calibration=0.0001*int(0.5+10000*mdsp->GetDACVoltage(3));

	// Flags
	abort=(mdsp->GetFlag(ABORT_FLAG)!=0);
	startofburst=(mdsp->GetFlag(SOB_SIG_FLAG)!=0);
	endofburst=(mdsp->GetFlag(EOB_SIG_FLAG)!=0);
	trigger=(mdsp->GetFlag(TRIGGER_FLAG)!=0);
	verbose=(mdsp->GetFlag(VERBOSE_FLAG)!=0);
	dataready=(mdsp->GetFlag(DSP_DATA_READY_FLAG)!=0);

	UpdateData(FALSE);

	GetDlgItem (IDC_LLCARD)->EnableWindow(mdsp->GetLLCard()!=NULL);
	GetDlgItem (IDC_TCCCARD)->EnableWindow(mdsp->GetTccCard()!=NULL);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}
