// ModuleDlg.cpp : implementation file
//

#include "stdafx.h"
#include "aldas.h"
#include "ModuleDlg.h"

#include "module.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// ModuleDlg dialog

ModuleDlg::ModuleDlg(CWnd* pParent /*=NULL*/, Module * m)
	: CDialog(ModuleDlg::IDD, pParent)
{
	module = m;
	//{{AFX_DATA_INIT(ModuleDlg)
	detectorName = _T("");
	numChannels = 0;
	hitPolarity = -1;
	biasVoltage = 0.0f;
	//}}AFX_DATA_INIT
}

void ModuleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(ModuleDlg)
	DDX_Text(pDX, IDC_DETECTOR_NAME, detectorName);
	DDX_Text(pDX, IDC_NUM_CHANNELS, numChannels);
	DDX_Radio(pDX, IDC_polar00, hitPolarity);
	DDX_Text(pDX, IDC_BIAS_VOLTAGE, biasVoltage);
	//}}AFX_DATA_MAP
}

BOOL ModuleDlg::OnInitDialog() {
	if (module) {
		detectorName = module->GetModuleName();
		numChannels = module->GetNumChannels();
		hitPolarity = module->GetHitPolarity();
		biasVoltage = module->GetBiasVoltage();
		UpdateData(FALSE);
	}
	return TRUE;
}

BEGIN_MESSAGE_MAP(ModuleDlg, CDialog)
	//{{AFX_MSG_MAP(ModuleDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// ModuleDlg message handlers

void ModuleDlg::OnOK() 
{
	UpdateData();

	if (module) {
		module->SetModuleName(detectorName);
		module->SetNumChannels(numChannels);
		module->SetHitPolarity(hitPolarity);
		module->SetBiasVoltage(biasVoltage);
	}

	CDialog::OnOK();
}
