// SelectDspDlg.cpp : implementation file
//

#include "stdafx.h"
#include <afxtempl.h>
#include "ALDAS.h"
#include "SelectDspDlg.h"

#include "message.h"
#include "dspcard.h"
#include "llcard.h"
//#include "hybrid.h"
//#include "module.h"

#include "hal.h"
#include "module.h"
#include "PlaceDoc.h"
#include "ALDASDoc.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// CSelectDspDlg dialog
extern CALDASApp theApp;


CSelectDspDlg::CSelectDspDlg(CWnd* pParent)
	: CDialog(CSelectDspDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSelectDspDlg)
	link = 0;
	theFilter = None;
	//}}AFX_DATA_INIT
}


void CSelectDspDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSelectDspDlg)
	DDX_Control(pDX, IDC_DSP, dspBox);
	DDX_Radio(pDX, IDC_LINK0, link);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSelectDspDlg, CDialog)
	//{{AFX_MSG_MAP(CSelectDspDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// CSelectDspDlg message handlers


BOOL CSelectDspDlg::OnInitDialog() 
{
	int i, j;
	DSP* dsp;
	LLCard * llCard;
	Module * module;
	BOOL AddThisDSP = FALSE;
	CDialog::OnInitDialog();

	// get the list of dsps into the dspBox of the dlg:
	CDocTemplate* templ=theApp.GetDocTemplate("ALDAS");
	POSITION docPos=templ->GetFirstDocPosition();
	CALDASDoc* mainDoc=(CALDASDoc*)templ->GetNextDoc(docPos);
	hal = mainDoc->GetHal();
	
	int numDsps = hal->dspArray.GetSize();
	for (i=0; i<numDsps; i++) {
		AddThisDSP = FALSE;
		dsp=hal->dspArray[i];

		switch (theFilter) {
		case llCards:
			llCard = dsp->GetLLCard();
			if (llCard != NULL)
				AddThisDSP = TRUE;
			break;
		case Modules:
			llCard = dsp->GetLLCard();
			if (llCard)
				for (j=0; j<4; j++) {
					module = llCard->GetModule(j);
					if (module != NULL)
						AddThisDSP = TRUE;
				}
			break;
		case None:
			AddThisDSP = TRUE;
			break;
		}

		if (AddThisDSP) {
			dspBox.InsertString(i, dsp->GetName());
			dspBox.SetItemDataPtr(i, dsp);
		}
	}
	dspBox.SetCurSel(0);
	

	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


void CSelectDspDlg::OnOK() 
{
	// TODO: Add extra validation here
	int i=dspBox.GetCurSel();
	if (i==CB_ERR) {// something went wrong with the selection
		dsp=NULL;
		TRACE ("CSelectDspDlg::OnOK(): Can not read a selection.\n");
	} else {
		dsp=(DSP*) (dspBox.GetItemDataPtr(i));
	}
	CDialog::OnOK();
}
