// ALDASDoc.h : interface of the CALDASDoc class

//#include "dspcard.h"
class DSP;
class HAL;

#define MAXINFO 12
#define MAXDSP 6
#define MAXLINK 4

class CALDASDoc : public CPlaceDoc
{
friend class CALDASView;

protected: // create from serialization only
	CALDASDoc();
	DECLARE_DYNCREATE(CALDASDoc)
	void InitializeSystem();

// Operations
public:
	HAL * GetHal();
//	DSP* GetNextDsp(POSITION * pos);
//	POSITION GetFirstDspPos();
//	int GetNumDSPs();
//	DSP * GetCard(int);
//	void AddCard(UINT base);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CALDASDoc)
	public:
//	virtual BOOL OnNewDocument();
	virtual void Serialize(CArchive& ar);
	virtual BOOL OnOpenDocument(LPCTSTR lpszPathName);
	virtual void OnCloseDocument();
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CALDASDoc();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

// Generated message map functions
protected:
	//{{AFX_MSG(CALDASDoc)
	afx_msg void OnFileSave();
	afx_msg void OnSendMessage();
	afx_msg void OnNeverShowMessages();
	afx_msg void OnUpdateNeverShowMessages(CCmdUI* pCmdUI);
	afx_msg void OnUpdateGetMessage(CCmdUI* pCmdUI);
	afx_msg void OnUpdateSendMessage(CCmdUI* pCmdUI);
	afx_msg void OnViewErrorMessages();
	afx_msg void OnViewAllMessages();
	afx_msg void OnUpdateViewAllMessages(CCmdUI* pCmdUI);
	afx_msg void OnUpdateViewErrorMessages(CCmdUI* pCmdUI);
	afx_msg void OnModifyConfig();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
//	UINT mNumDSPCards;
//	CObList DspList;
	HAL * hal;
//	UINT mDisplayMessages;
public:
	int IsDspActive();
	static UINT NumDocsOpen;
//	CString system_path;
};
