// CChargeScanView.cpp : implementation of the CChargeScanView class
//

#include "stdafx.h"
#include <afxtempl.h>
#include "ALDAS.h"
#include <math.h>

#include "PlaceDoc.h"
#include "ScanDoc.h"
#include "Axis.h"
#include "ScanView.h"
#include "HeadingDlg.h"
#include "NoiseFitDlg.h"
#include "Data.h"
#include "FitFunction.h"
#include "ChargeScanDoc.h"
#include "ChargeScanView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

// CChargeScanView

IMPLEMENT_DYNCREATE(CChargeScanView, CScrollView)

BEGIN_MESSAGE_MAP(CChargeScanView, CScrollView)
	//{{AFX_MSG_MAP(CChargeScanView)
	ON_WM_LBUTTONDOWN()
	ON_WM_MOUSEMOVE()
	ON_COMMAND(ID_HISTOGRAM_VIEW, OnHistogramView)
	ON_UPDATE_COMMAND_UI(ID_HISTOGRAM_VIEW, OnUpdateHistogramView)
	ON_COMMAND(ID_LINE_FIT_VIEW, OnLineFitView)
	ON_UPDATE_COMMAND_UI(ID_LINE_FIT_VIEW, OnUpdateLineFitView)
	ON_COMMAND(ID_SETHEADING, OnSetheading)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

// CChargeScanView construction/destruction

CChargeScanView::CChargeScanView()
{
	// TODO: add construction code here
  printRect.SetRect(0, 0, 200, 300);
}

CChargeScanView::~CChargeScanView()
{
}


CChargeScanDoc * CChargeScanView::GetDocument()
{ 
	return (CChargeScanDoc*)m_pDocument;
}

#ifdef _DEBUG
void CChargeScanView::AssertValid() const
{
	CView::AssertValid();
}

void CChargeScanView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

#endif //_DEBUG


// CChargeScanView message handlers
void CChargeScanView::OnMouseMove(UINT nFlags, CPoint point) 
{	
	CScanView::OnMouseMove(nFlags, point);
}

void CChargeScanView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	int ch; // channel number
	int i, link;
	float triggers; 
	CChargeScanDoc* pDoc = GetDocument();
	CAxis *xAxis, *yAxis;

	if (viewMode == LineFitView) {
		ch=pDoc->axis[0]->GetChannelNumber(point);
		link = pDoc->dataArray[0]->GetLink();
		if (ch>=0) {// get the rawdata to be displayed:			
			xTemp=new float[pDoc->numPoints];
			yTemp=new float[pDoc->numPoints];
			eTemp=new float[pDoc->numPoints];
			for (i=0; i<pDoc->numPoints; i++){
				triggers=pDoc->dataArray[i]->GetTriggers();
				if (triggers<=0) triggers=1.0;
				yTemp[i]=pDoc->dataArray[i]->hits[ch]/triggers;
				eTemp[i]=sqrt(yTemp[i]*(1-yTemp[i])/triggers);
				xTemp[i]=pDoc->dataArray[i]->GetDSPDacVoltage(3);
			}
			yAxis=new CAxis("Efficiency", pDoc->numPoints, yTemp, eTemp, NULL);
			xAxis=new CAxis("Calibration", pDoc->numPoints, xTemp, NULL, NULL);
			yAxis->SetType(LinAxis);

			CNoiseFitDlg dlg;
			CFitFunction* func = new CFitFunction( InvErrorType, pDoc->axis[0]->GetData()[ch], pDoc->axis[1]->GetData()[ch]);
			dlg.Init(pDoc->axis[0], pDoc->axis[1], ch, pDoc->badChannel, xAxis, yAxis, func);
			dlg.boxTitle = "Qinj Scan Fit";
			if (dlg.DoModal()==IDOK) {
				pDoc->badChannel[i] = dlg.badChannelCheck;
			}
			delete[] xTemp;
			delete[] yTemp;
			delete[] eTemp;
			delete func;

			delete xAxis;
			delete yAxis;
			xAxis=NULL;
			yAxis=NULL;
			xTemp=NULL;
			yTemp=NULL;
			eTemp=NULL;
		}
	}
	
	CScrollView::OnLButtonDown(nFlags, point);
}

void CChargeScanView::OnHistogramView() 
{
	CScanView::OnHistogramView();
}


void CChargeScanView::OnSetheading() 
{
	CScanView::OnSetheading();
}

void CChargeScanView::OnUpdateHistogramView(CCmdUI* pCmdUI) 
{
	CScanView::OnUpdateHistogramView(pCmdUI);
}

void CChargeScanView::OnLineFitView() 
{
	CScanView::OnLineFitView();
}

void CChargeScanView::OnUpdateLineFitView(CCmdUI* pCmdUI) 
{
	CScanView::OnUpdateLineFitView(pCmdUI);
}
